@cls
@echo on
set "PYTHONHOME=e:\ProgramFiles\python-3.5.3"
@set "PYTHONCASEOK=1"
@cd /d "%~dp0"
set "ROOT=%cd%"
set "ZIP=%ROOT%\download\7z\Files\7-Zip\7z.exe"
set "CURL=%ROOT%\gitbash\curl.exe"
path=%PYTHONHOME%;%ROOT%\download\7z\Files\7-Zip;%PYTHONHOME%\Scripts;.;C:\Windows;C:\Windows\system32;
@if not exist "%CURL%" echo. unable to install [%PYTHONHOME%]. missing [%CURL%] && exit /b 1
@if not exist "%PYTHONHOME%\." goto install
@echo.[%PYTHONHOME%] ready. run vipaccess to create a Symantech Token
@exit /b 0

:install
@echo WARNING: Reinstalling [%PYTHONHOME%]    Press Ctrl-C to abort
@pause
@rmdir /S /Q "%ROOT%\download\."  >nul 2>&1
@rmdir /S /Q "%PYTHONHOME%\."     >nul 2>&1


@call :getfile "https://bootstrap.pypa.io"                              "get-pip.py"                          "%ROOT%\download\pip"
@call :getmsi  "http://d.7-zip.org/a"                                   "7z1604.msi"                          "%ROOT%\download\7z"
@call :getzip  "https://www.python.org/ftp/python/3.5.3"                "python-3.5.3rc1-embed-win32.zip"     "%PYTHONHOME%"
@call :getzip  "https://github.com/winpython/winpython/archive"         "master.zip"                          "%PYTHONHOME%"
@call :getzip  "https://github.com/cyrozap/python-vipaccess/archive"    "master.zip"                          "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "core.msi"                            "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "core_d.msi"                          "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "core_pdb.msi"                        "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "dev.msi"                             "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "dev_d.msi"                           "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "doc.msi"                             "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "exe.msi"                             "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "exe_d.msi"                           "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "exe_pdb.msi"                         "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "launcher.msi"                        "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "lib.msi"                             "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "lib_d.msi"                           "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "lib_pdb.msi"                         "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "tcltk.msi"                           "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "tcltk_d.msi"                         "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "tcltk_pdb.msi"                       "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "test.msi"                            "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "test_d.msi"                          "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "test_pdb.msi"                        "%PYTHONHOME%"
@call :getmsi  "https://www.python.org/ftp/python/3.5.3/win32rc1"       "tools.msi"                           "%PYTHONHOME%"
@call :getfile "https://github.com/sfbahr/PyCrypto-Wheels/raw/master"   "pycrypto-2.7a1-cp35-none-win32.whl"  "%ROOT%\download"
                                                          

@echo Installing pip
python %PYTHONHOME%\lib\ensurepip\_bundled\pip-9.0.1-py2.py3-none-any.whl\pip    install %PYTHONHOME%\lib\ensurepip\_bundled\pip-9.0.1-py2.py3-none-any.whl
python %PYTHONHOME%\lib\ensurepip\_bundled\lxml-3.7.2-cp36-cp36m-win32.whl\lxml  install %PYTHONHOME%\lib\ensurepip\_bundled\lxml-3.7.2-cp36-cp36m-win32.whl

@echo Updating:   [pip setuptools]
cd "%ROOT%\download\pip"
python -m pip install -U pip setuptools

@echo Installing: [%PYTHONHOME%\winpython-master]
cd "%PYTHONHOME%\winpython-master"
python setup.py install

@echo Installing:   [pycrypto]
cd "%ROOT%\download"
python -m pip install pycrypto-2.7a1-cp35-none-win32.whl

@echo Installing:   [lxml]
cd "%ROOT%\download"
@echo.pythonlibs doesnt allow automated downloads. 
@echo.please open this URL in your browser 
@echo.http://www.lfd.uci.edu/~gohlke/pythonlibs/
@echo.type Ctrl-f lxml Enter
@echo click the link for lxml-3.7.2-cp35-cp35m-win32.whl   (Ctrl-f wont work)
@echo.Please save or move the downloaded the file to "%ROOT%\download"
@pause
@pause
python -m pip install lxml-3.7.2-cp35-cp35m-win32.whl


@echo Extracting Grammar.txt from %PYTHONHOME%\python35.zip
%ZIP% x "%PYTHONHOME%\python35.zip" -o"%PYTHONHOME%" -aoa "lib2to3\Grammar.txt" >nul 2>&1
@if %errorlevel% neq 0 @ECHO. && @ECHO.ERROR unzip  failed.       press Ctrl-c to abort install && @pause 
del "%PYTHONHOME%\python35.zip"


@echo Installing: [%PYTHONHOME%\python-vipaccess-master]
cd "%PYTHONHOME%\python-vipaccess-master"
python setup.py install

:done
@echo.running vipaccess.exe to verify install
vipaccess.exe

:cleanup
@echo Removing temp msi and zip files
@pause
@pause
del "%PYTHONHOME%\*.msi"
del "%ROOT%\download\*.zip"
del "%ROOT%\download\*.msi"
del "%ROOT%\download\7z\*.msi"
@cd "%ROOT%"
@echo Install complete.
@exit /b 0



:getmsi
@set "U=%~1"
@set "F=%~2"
@call :getfile "%U%" "%F%" "%ROOT%\download"
@set "P=%~3
@mkdir "%P%" >nul 2>&1
msiexec /a "%F%" /qb TARGETDIR="%P%"
@if errorlevel 1 @ECHO. && @ECHO.ERROR msiexec failed.      press Ctrl-c to abort install  && @pause
@exit /b 0


:getzip
@set "U=%~1"
@set "F=%~2"
@call :getfile "%U%" "%F%" "%ROOT%\download"
@set "P=%~3
@mkdir "%P%" >nul 2>&1
%ZIP% x "%F%" -o"%P%" -aoa *   >nul 2>&1
@if %errorlevel% neq 0 @ECHO. && @ECHO.ERROR unzip  failed.       press Ctrl-c to abort install && @pause 
@exit /b 0


:getfile
@set "U=%~1"
@set "F=%~2"
@set "P=%~3
@mkdir %P% >nul 2>&1
@cd "%P%"  >nul 2>&1
@echo %cd%
%CURL% -L -k -O "%U%/%F%"
@if %errorlevel% neq 0 @ECHO. && @ECHO.ERROR getfile failed.      press Ctrl-c to abort install  && @pause 
@exit /b 1
